package cerebral.controls;

import java.awt.event.MouseEvent;
import java.util.Iterator;

import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;
import cerebral.Cerebral;
import cerebral.ViewCoordinator;

import prefuse.controls.ControlAdapter;

public class NeighbourHighlightToGroupControl extends ControlAdapter {

    private String activity = null;
    private String group;
    private ViewCoordinator viewCoordinator;
       
    public NeighbourHighlightToGroupControl(String activity, String group, ViewCoordinator viewCoordinator) {
        this.activity = activity;
        this.group = group;
        this.viewCoordinator = viewCoordinator;
    }
    
    /**
     * @see prefuse.controls.Control#itemEntered(prefuse.visual.VisualItem, java.awt.event.MouseEvent)
     */
    public void itemEntered(VisualItem item, MouseEvent e) {
        if ( item instanceof NodeItem ){
            NodeItem n = (NodeItem) item;
            viewCoordinator.setHover(item.getString(Cerebral.STRING_ID), true);
            Iterator iter = n.edges();
            while ( iter.hasNext() ) {
                EdgeItem eitem = (EdgeItem)iter.next();
                NodeItem nitem = eitem.getAdjacentItem(n);
                viewCoordinator.select(group, nitem, true);
                viewCoordinator.select(group, eitem, true);
            }
            viewCoordinator.run(activity);
                 
         }
    }
    
    /**
     * @see prefuse.controls.Control#itemExited(prefuse.visual.VisualItem, java.awt.event.MouseEvent)
     */
    public void itemExited(VisualItem item, MouseEvent e) {
        if ( item instanceof NodeItem ){
            viewCoordinator.setHover(item.getString(Cerebral.STRING_ID), false);
            viewCoordinator.clearFocusGroup(group);
            viewCoordinator.run(activity);
        }
    }
    
    

}
