package cerebral.parallelCoordinates;

import java.util.Iterator;

import prefuse.action.GroupAction;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.VisualItem;

public class InteractiveFilter extends GroupAction {

	private TupleSet selectedItems;
	public InteractiveFilter(String group, TupleSet selectedItems){
		m_group = group;
		this.selectedItems = selectedItems;
	}
	
	public void run(double frac) {
		Iterator items = m_vis.items(m_group);
	    while (items.hasNext()) {	    	
	           VisualItem item = (VisualItem) items.next();
	           if (selectedItems.containsTuple(item)){
	        	   item.setInteractive(!item.getBoolean(ParallelCoordinates.IGNORE));	        	   
	           }else{
	        	   item.setInteractive(false);
	           }
	      }
	}

}
