package cerebral.parallelCoordinates;

import java.awt.Color;

import cerebral.colors.ColorManager;


import prefuse.Visualization;
import prefuse.action.assignment.ColorAction;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;

public class MyColorAction extends ColorAction {

	private static float[] hsbVals = new float[3];

	private Visualization vis;

	public MyColorAction(String group, Visualization vis) {
		super(group, VisualItem.FILLCOLOR);
		this.vis = vis;
	}

	public int getColor(VisualItem item) {
        if (item.isHover())
            return ColorLib.rgb(255,0,0);
        
		TupleSet selected = vis.getFocusGroup(ParallelCoordinates.SELECTED);

		if (selected.containsTuple(item)) {

			if (!item.getBoolean(ParallelCoordinates.IGNORE)) {
				return ColorLib.gray(0);
			} else {
                return ColorManager.increasedContrast(ColorLib.color(m_vis.getDisplay(0)
                        .getBackground()));
			}

		} else {
            return ColorManager.increasedContrast(ColorLib.color(m_vis.getDisplay(0)
                    .getBackground()));
		}
	}

	public static int changeSaturationTo(Color c, float saturation) {
		if (c.getRed() == c.getGreen() && c.getGreen() == c.getBlue()) {
			// a grey scale. Change brightness instead of saturation
			return ColorLib.gray(255 - (int) (saturation * 255));
		} else {
			Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), hsbVals);
			return ColorLib.hsb(hsbVals[0], saturation, hsbVals[2]);
		}
	}

}
