package cerebral.render;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import prefuse.Visualization;
import prefuse.render.Renderer;
import prefuse.util.ColorLib;
import prefuse.util.StrokeLib;
import prefuse.visual.VisualItem;
import cerebral.Cerebral;
import cerebral.layout.SearchGridLayout;

public class SmallLineDividerRenderer implements Renderer {

    private final int LINE_THICKNESS = 2;
    private Visualization vis;
    private Rectangle2D r = new Rectangle2D.Double();
    private Rectangle2D r2= new Rectangle2D.Double();
  
    public SmallLineDividerRenderer ( Visualization vis){
        this.vis =vis;
    }

    public void render(Graphics2D g, VisualItem item) {
            vis.getBounds(Cerebral.NODES,r);
            vis.getBounds(Cerebral.LINE_DIVIDER_LABELS, r2);
        	
            double y =  item.getY();
            g.setColor(ColorLib.getColor(0.4f,0.4f,0.4f));
            g.setStroke(StrokeLib.getStroke(LINE_THICKNESS, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
            g.drawLine((int) r.getMinX(), (int)y, (int) (r.getWidth() + r2.getWidth() + SearchGridLayout.SCALE), (int)y);   
    }
        
    

    public boolean locatePoint(Point2D p, VisualItem item) {
        return item.getBounds().contains(p);
    }

    public void setBounds(VisualItem item) {
    	Rectangle2D r = Cerebral.getEndBounds(item.getVisualization(), Cerebral.NODES);
    	vis.getBounds(Cerebral.LINE_DIVIDER_LABELS, r2);
    	
        int lineWidth = (int) (r.getWidth() + r2.getWidth() + SearchGridLayout.SCALE);
        double y  =  item.getY();
        item.setBounds(r.getMinX(), y-LINE_THICKNESS, lineWidth, 2*LINE_THICKNESS);
    }

   
}
