package cerebral.sort;

import cerebral.Cerebral;
import prefuse.Visualization;
import prefuse.data.Table;
import prefuse.data.column.ColumnMetadata;
import prefuse.visual.AggregateItem;
import prefuse.visual.DecoratorItem;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;
import prefuse.visual.sort.ItemSorter;

public class MyRenderSorter extends ItemSorter {

	private Table edges;
    public MyRenderSorter(Table edges) {
    	this.edges = edges;
	}
	public int score(VisualItem item) {
	        int category = 5;
	        if (item instanceof NodeItem){
                category = 2;
            }else  if ( item instanceof EdgeItem ) {
	            category = 1;
	        } else if ( item instanceof AggregateItem ) {
	            category = 0;
	        } else if ( item instanceof DecoratorItem ) {
	            category = 3;
	        } 
	        if (item.isInGroup(Cerebral.FRAMING_BORDER)){
	            category = 4;
	        }
	            
	        
	        int score = (1<<(26+category));
	            
	        if ( item.isHover() ) {
	            score += (1<<24);
	        }
	        if ( item.isHighlighted() || item.isInGroup(Cerebral.NEIGHB_SELECT) ) {
	            score += (1<<23);
	        }
	        if ( item.isInGroup(Cerebral.SELECTED)  ) {
	            score += (1<<22);
	        }
	        if ( item.isInGroup(Visualization.SEARCH_ITEMS) ) {
	            score += (1<<21);
	        }
	        
	        if ( item instanceof EdgeItem ) {
	        	//Sort to support our pseudo alpha blending.
	        	
	        	EdgeItem edge = (EdgeItem)item;
	        	
	        	ColumnMetadata edgeLengthMetadata = edges.getMetadata(Cerebral.EDGE_LENGTH);
				int maxRow =edgeLengthMetadata.getMaximumRow();					
				float maxLength = edges.getInt(maxRow, Cerebral.EDGE_LENGTH);
				int edgeLength = edge.getInt(Cerebral.EDGE_LENGTH);
			    double normalizedLength= 255*(edgeLength / maxLength);
			   
				//Darker edges should go on top
		        score +=255- normalizedLength;   
	        }
	        
	        if (item instanceof DecoratorItem){
	        	DecoratorItem di = (DecoratorItem)item;
	        	Object o = di.getDecoratedItem();
	        	if (o instanceof NodeItem){
	        		score +=1;
	        	}
	        }

	        return score;
	    }
}
